// ==============================================================================
// 												
// Author:		if this code doesn't work, it was written by Alan Smithee
//
// Copyright:	Plan Software GmbH, Saarbrcken
//  
// ==============================================================================

// global handler for key events
document.onkeydown=HandleKeyRequest;

var treeArray = new Array();

// associative array from dialog id to corresponding menu id
treeArray['EKCURRENTDLG']								= '';					// to prevent crashes
treeArray['IDD_MAIN']									= 'IDC_START';
treeArray['IDD_START']									= 'IDC_START';
treeArray['IDD_ABOUT']									= 'IDC_ABOUT';
treeArray['IDD_PROJECTLIST']							= 'IDC_PROJEKTORGANISATION';
treeArray['IDD_ADRESSES']								= 'IDC_ADRESSE';
treeArray['IDD_MEASUREMENT_SYSTEM']						= 'IDC_MASSSYSTEM';
treeArray['IDD_DEFAULT_MASSEINHEITEN']					= 'IDC_DEFAULT_MASSEINHEITEN';
treeArray['IDD_DIRECT_SELECTION']						= 'IDC_ANTRIEBSAUSWAHL_DIREKT';
treeArray['IDD_APPLICATION_SELECTION']					= 'IDC_MECH_BEWEGUNG';
treeArray['IDD_MECHANICS']								= 'IDC_DATEN_MECHANIK';
treeArray['IDD_MECHANICS_ROLLER_FEED']					= 'IDC_DATEN_MECHANIK';
treeArray['IDD_MECHANICS_ROTARY_KNIFE']					= 'IDC_DATEN_MECHANIK';
treeArray['IDD_TYPISCHE_REIBWERTE']						= 'IDC_DATEN_MECHANIK';
treeArray['IDD_TYPISCHE_DICHTEN']						= 'IDC_DATEN_MECHANIK';
treeArray['IDD_CALCULATION_MASS']						= 'IDC_DATEN_MECHANIK';
treeArray['IDD_CALCULATION_INERTIA_WORKPIECE']			= 'IDC_DATEN_MECHANIK';
treeArray['IDD_CALCULATION_INERTIA_TABLE']				= 'IDC_DATEN_MECHANIK';
treeArray['IDD_CALCULATION_INERTIA_COUPLING']			= 'IDC_DATEN_MECHANIK';
treeArray['IDD_CALCULATION_GEAR_RATIO']					= 'IDC_DATEN_MECHANIK';
treeArray['IDD_CALCULATION_INERTIA_ROLL_FEED']	    	= 'IDC_DATEN_MECHANIK';
treeArray['IDD_CALCULATION_INERTIA_BELT_AND_PULLEY']	= 'IDC_DATEN_MECHANIK';
treeArray['IDD_CALCULATION_INERTIA_RACK_AND_PINION']	= 'IDC_DATEN_MECHANIK';
treeArray['IDD_CALCULATION_INERTIA_NUT']				= 'IDC_DATEN_MECHANIK';
treeArray['IDD_CALCULATION_INERTIA_SPINDLE']			= 'IDC_DATEN_MECHANIK';
treeArray['IDD_CALCULATION_INERTIA_ROLLER_COUPLING']	= 'IDC_DATEN_MECHANIK';
treeArray['IDD_CALCULATION_INERTIA_ROTARY_KNIFE']		= 'IDC_DATEN_MECHANIK';
treeArray['IDD_CALCULATION_INERTIA_STRAIGHTENING_ROLLERS'] = 'IDC_DATEN_MECHANIK';
treeArray['IDD_CALCULATION_INERTIA_FEED_ROLLERS']		= 'IDC_DATEN_MECHANIK';
treeArray['IDD_RELATIVE_ONTIME_LINEAR']					= 'IDC_DATEN_BEWEGUNG';
treeArray['IDD_RELATIVE_ONTIME_ROTATIVE']				= 'IDC_DATEN_BEWEGUNG';
treeArray['IDD_RELATIVE_ONTIME_ROTARY_DRIVE']			= 'IDC_DATEN_BEWEGUNG';
treeArray['IDD_MOTION_PROFILE']							= 'IDC_DATEN_BEWEGUNG';
treeArray['IDD_MOTION_PROFILE_ROTATIVE']				= 'IDC_DATEN_BEWEGUNG';
treeArray['IDD_MOTION_PROFILE_WINDER']					= 'IDC_DATEN_BEWEGUNG';
treeArray['IDD_MOTION_PROFILE_ROTARY_KNIFE']			= 'IDC_DATEN_BEWEGUNG';
treeArray['IDD_MOTION_PROFILE_FLYING_CUTOFF']			= 'IDC_DATEN_BEWEGUNG';
treeArray['IDD_MOTION_PROFILE_ROLL_FEED']	    		= 'IDC_DATEN_BEWEGUNG';
treeArray['IDD_MOTION_PROFILE_IMAGE']					= 'IDC_DATEN_BEWEGUNG';
treeArray['IDD_MOTION_PROFILE_ROTATIVE_IMAGE']			= 'IDC_DATEN_BEWEGUNG';
treeArray['IDD_MOTION_PROFILE_ROTARY_KNIFE_IMAGE']		= 'IDC_DATEN_BEWEGUNG';
treeArray['IDD_MOTION_PROFILE_FLYING_CUTOFF_IMAGE']		= 'IDC_DATEN_BEWEGUNG';
treeArray['IDD_MOTION_PROFILE_ROLL_FEED_IMAGE']	    	= 'IDC_DATEN_BEWEGUNG';
treeArray['IDD_DETAILS_ROTATIVE']						= 'IDC_ANTRIEBSAUSWAHL';
treeArray['IDD_DETAILS_LINEAR']							= 'IDC_ANTRIEBSAUSWAHL';
treeArray['IDD_DETAILS_MAIN_SPINDLE']					= 'IDC_ANTRIEBSAUSWAHL';
treeArray['IDD_DETAILS_S1']								= 'IDC_ANTRIEBSAUSWAHL';
treeArray['IDD_MOTORSEARCH_LINEAR']						= 'IDC_ANTRIEBSAUSWAHL';
treeArray['IDD_MOTORSEARCH_ROTARY_KNIFE']				= 'IDC_ANTRIEBSAUSWAHL';
treeArray['IDD_MOTORSEARCH_ROTATIVE']					= 'IDC_ANTRIEBSAUSWAHL';
treeArray['IDD_MOTORSEARCH_S1']							= 'IDC_ANTRIEBSAUSWAHL';
treeArray['IDD_MOTORSEARCH_MAIN_SPINDLE']				= 'IDC_ANTRIEBSAUSWAHL';
treeArray['IDD_AXIS_OVERVIEW']							= 'IDC_ANTRIEBSUEBERSICHT';
treeArray['IDD_AXIS_OVERVIEW_DIRECT']					= 'IDC_ANTRIEBSUEBERSICHT_DIREKT';
treeArray['IDD_OTHER_SETTINGS']							= 'IDC_SONSTIGE_EINSTELLUNGEN';
treeArray['IDD_LANGUAGES']								= 'IDC_SPRACHEN';
treeArray['IDD_UPDATE'] 								= 'IDC_UPDATE';
treeArray['IDD_VORZUGSTYPEN'] 							= 'IDC_VORZUGSTYPEN';

// associative array from a stage id to all menu ids that can be evoked in this stage
var stageArray = new Array();
stageArray['START']							= 'IDC_DIREKTE_ANTRIEBSAUSWAHL,IDC_ANTRIEBSBERECHNUNG,IDC_ABOUT,IDC_SPRACHE_BUTTON,IDC_IMPRESSUM_BUTTON,IDC_HILFE_BUTTON,IDC_START,IDC_PROJEKTORGANISATION,IDC_ADRESSE,IDC_MASSSYSTEM,IDC_SONSTIGE_EINSTELLUNGEN,IDC_SPRACHEN,IDC_DEFAULT_MASSEINHEITEN,IDC_UPDATE,IDC_VORZUGSTYPEN';
stageArray['SELECTION_PROJECT_LIST']		= 'IDC_DIREKTE_ANTRIEBSAUSWAHL,IDC_ANTRIEBSBERECHNUNG,IDC_ABOUT,IDC_SPRACHE_BUTTON,IDC_START,IDC_PROJEKTORGANISATION,IDC_ADRESSE,IDC_MASSSYSTEM,IDC_SONSTIGE_EINSTELLUNGEN,IDC_VORZUGSTYPEN,IDC_SPRACHEN,IDC_DEFAULT_MASSEINHEITEN';
stageArray['SELECTION_FINISHED']			= 'IDC_DIREKTE_ANTRIEBSAUSWAHL,IDC_ANTRIEBSBERECHNUNG,IDC_ABOUT,IDC_SPRACHE_BUTTON,IDC_START,IDC_PROJEKTORGANISATION,IDC_ADRESSE,IDC_MASSSYSTEM,IDC_SONSTIGE_EINSTELLUNGEN,IDC_VORZUGSTYPEN,IDC_SPRACHEN,IDC_DEFAULT_MASSEINHEITEN';
//stageArray['DIRECT_SELECTION']				= 'IDC_ANTRIEBSAUSWAHL_DIREKT,IDC_ANTRIEBSUEBERSICHT_DIREKT';
//stageArray['FULL_SELECTION']				= 'IDC_MECH_BEWEGUNG';
//stageArray['FULL_SELECTION_IN_PROGRESS']	= 'IDC_MECH_BEWEGUNG,IDC_DATEN_MECHANIK,IDC_DATEN_BEWEGUNG,IDC_ANTRIEBSAUSWAHL,IDC_ANTRIEBSUEBERSICHT';
//stageArray['MODIFY_SELECTION']				= 'IDC_DATEN_MECHANIK,IDC_DATEN_BEWEGUNG,IDC_ANTRIEBSAUSWAHL,IDC_ANTRIEBSUEBERSICHT';
stageArray['DIRECT_SELECTION']				= '';
stageArray['FULL_SELECTION']				= '';
stageArray['FULL_SELECTION_IN_PROGRESS']	= '';
stageArray['MODIFY_SELECTION']				= '';


/**
 * eventhandler for handling keydowns for the hidden feature
 *
 * @param KeyEvent : key event
 */
function HandleKeyRequest( KeyEvent ) 
{
    if ( !KeyEvent )
	    KeyEvent = window.event;
	
	if ( KeyEvent )
	{
	    var code = 0;
	    if ( KeyEvent.which ) // netscape syntax
		    code = KeyEvent.which;
	    else if ( KeyEvent.keyCode ) // internet explorer syntax
		    code = KeyEvent.keyCode;

	    if ( KeyEvent.altKey && KeyEvent.ctrlKey && ( code == 77 ) )  // ctrl alt m
		    ekSubmit( 'CPM_EVENT', 'RFrame' );
	    else if ( code == 112 )  // F1
	        ShowDocument( 'QUICKSTART' );
	}
}



// ==============================================================================
// guess
// ==============================================================================

function doNothing()
{
}


/**
 * update UI language
 *
 * @param event: id of button that evokes this function
 */
function UpdateLanguages( event )
{
	ekSubmit( event, '_top' );
}


/**
 * asks wether the user wants to proceed with the cancel event
 *
 * @param event: id of button that evokes this function
 */
function CheckCancelEvent( event )
{
	// check if message should be displayed
	var elCheck = document.getElementById( 'CHECK_CANCEL_EVENT' );
	if ( elCheck == null )
		elCheck = parent.document.getElementById( 'CHECK_CANCEL_EVENT' );

	if ( ( elCheck == null ) || ( elCheck.value == 'true' ) )
	{
		// get message
		var elMsg = document.getElementById( 'CANCEL_MESSAGE' );
		if ( elMsg == null )
			elMsg = parent.document.getElementById( 'CANCEL_MESSAGE' );

		// display message
		var ret = null;
		if ( elMsg != null )
			ret = window.confirm( elMsg.value );

		if ( ret )
			ekSubmit( event );
	}
	else ekSubmit( event );
}


/**
 * asks wether the user wants to proceed with deleting the current selected motion phase
 *
 * @param event: id of button that evokes this function
 */
function CheckDeletePhase( event )
{
	var strMessage = document.getElementById( 'DELETE_PHASE_MESSAGE' ).value;
	var elTable = document.getElementById( 'IDC_MOTION_PROFILE_TABLE' );
	var strSelectedRowID = elTable.getAttribute( 'lastselectedrowid' );

	var ret = null;
	if ( ( strSelectedRowID != '-1' ) && ( strSelectedRowID != '' ) && 
	     ( strMessage != '' ) )
	{
		var strShouldCheck = document.getElementById( 'CHECK_DELETE_PHASE' ).value;
		if ( strShouldCheck == 'true' )
			ret = window.confirm( strMessage );
		else ret = 1;
	}

	if ( ret )
		ekSubmit( event );
}


/**
 * asks wether the user wants to proceed with deleting the current selected connection element
 *
 * @param event: id of button that evokes this function
 */
function CheckDeleteElement( event )
{
	var element = document.getElementById( 'DELETE_ELEMENT_MESSAGE' );
	if ( element )
	{
		var ret = null;
		var elSelected = document.getElementById( 'IDC_MECHANICS_IMAGE_SELECTED' ).value;
		if ( elSelected != '-1' )
		{
			var strShouldCheck = document.getElementById( 'CHECK_DELETE_ELEMENT' ).value;
			if ( strShouldCheck == 'true' )
			{
				var strMessage = element.value;
				if ( strMessage != '' )
					ret = window.confirm( strMessage );
			}
			else ret = 1;
		}

		if ( ret )
			ekSubmit( event );
	}
	else ekSubmit( event );
}


/**
 * asks wether the user wants to proceed with resetting the current dlg
 *
 * @param event: id of button that evokes this function
 */
function CheckResetEvent( event )
{
	var element = document.getElementById( 'RESET_MESSAGE' );
	if ( element )
	{
		var ret = null;
		var strMessage = element.value;
		if ( strMessage != '' )
			ret = window.confirm( strMessage );
		if ( ret )
			ekSubmit( event );
	}
	else ekSubmit( event );
}


/**
 * checks if the project has been modified, and asks wether the user wants to proceed with deleting the project
 *
 * @param event: id of button that evokes this function
 */
function CheckDeleteProjectEvent( event )
{
	var strFlag = document.getElementById( 'PROJECT_MODIFIED_FLAG' ).value;
	if ( strFlag == 'MODIFIED' )
	{
		var strMessage = document.getElementById( 'DELETE_PROJECT_MESSAGE' ).value;
		var ret = window.confirm( strMessage );
		if ( ret )
			ekSubmit( event );
	}
	else ekSubmit( event );
}


/**
 * checks if the project has been modified, and asks wether the user wants to proceed with deleting the current axis
 *
 * @param event: id of button that evokes this function
 */
function CheckDeleteAxisEvent( event )
{
	var elTable = document.getElementById( 'IDC_DRIVES_TABLE' );

	var strShouldCheck = document.getElementById( 'CHECK_DELETE_AXIS' ).value;
	if ( strShouldCheck == 'true' )
	{
		var strMessage = document.getElementById( 'DELETE_AXIS_MESSAGE' ).value;
		var ret = window.confirm( strMessage );
		if ( ret )
			ekSubmit( event );
	}
	else ekSubmit( event );
}


/**
 * display a warning/error message
 */
function DisplayErrorMessage()
{
	var strMessage = document.getElementById( 'ERROR_MESSAGE' ).value;
	
	if ( strMessage )
		alert( strMessage );
	document.getElementById( 'ERROR_MESSAGE' ).value = '';
}


/**
 * display a project warning/error message
 */
function DisplayProjectMessage()
{
	var strMessage = document.getElementById( 'PROJECT_MESSAGE' ).value;
	
	if ( strMessage )
		alert( strMessage );
	document.getElementById( 'PROJECT_MESSAGE' ).value = '';
}


/**
 * update the current project name in the main window
 */
function UpdateProjectName()
{
	var strName = document.getElementById( 'PROJECT_NAME' ).value;
	var element = parent.document.getElementById( 'IDC_PROJECT_NAME_LABEL' );
	
	if ( !element )
		element = document.getElementById( 'IDC_PROJECT_NAME_LABEL' );
	if ( element )
		element.innerHTML = strName;	
}


/**
 * update the current axis name in the main window
 */
function UpdateAxisName()
{
	var strName = document.getElementById( 'AXIS_NAME' ).value;
	var element = parent.document.getElementById( 'IDC_AXIS_NAME_LABEL' );
	if ( !element )
		element = document.getElementById( 'IDC_AXIS_NAME_LABEL' );
	if ( element )
		element.innerHTML = strName;	
}


/**
 * display the failure report in rtf-format in a new window
 */
function ShowFailureReport()
{
	var strFile = document.getElementById( 'FAILURE_REPORT' ).value;
	// don't try to display an empty file
	if ( strFile == '' )
		return;
	
	// show textfile
	var newWindowAttributes = "menubar=no toolbar=no,width=800,height=300";
    window.open( strFile, '', newWindowAttributes );

	// uncomment for rtf
	// self.open( strFile );
	document.getElementById( 'FAILURE_REPORT' ).value = '';
}


/**
 * display the jerk report in rtf-format in a new window
 */
function ShowJerkReport()
{
	var strFile = document.getElementById( 'JERK_REPORT' ).value;
	// don't try to display an empty file
	if ( strFile == '' )
		return;

	self.open( strFile );
	document.getElementById( 'JERK_REPORT' ).value = '';
}


/**
 * capture submit from menu, test it and do somethimg with it (or not, depending on the results of the test)
 *
 * @param ekSubmitEvent: id of menu event that is to check
 */
function TreeSubmit( ekSubmitEvent )
{
	// get current dialog id
	var curScreen = window.frames['RFrame'].document.isycat.EKCURRENTDLG.value;
	var curStage = window.frames['RFrame'].document.isycat.CURRENT_STAGE.value;
	
	var curCommand = treeArray[curScreen];

	// check if we need to change current dialog
	if ( curCommand === ekSubmitEvent )
		return;

	// do some checking based on internal stages
	if ( ( curCommand === 'IDC_ANTRIEBSAUSWAHL' ) && ( ekSubmitEvent === 'IDC_ANTRIEBSAUSWAHL_DIREKT' ) &&
	     ( ( curScreen === 'IDD_DETAILS_ROTATIVE' ) || ( curScreen === 'IDD_DETAILS_LINEAR' ) ||
		   ( curScreen === 'IDD_DETAILS_S1' ) || ( curScreen === 'IDD_DETAILS_MAIN_SPINDLE' ) ) )
		return;

	// test if next stage is allowed
	if ( stageArray[curStage] != undefined )
	{
		// get all stages that are reachable from the current one
		var aStages = stageArray[curStage].split(',');

		// if event to submit is not reachable, show message and quit
		var bFound = false;
		for( var i = 0; i < aStages.length; i++ )
		{
			if ( aStages[i] == ekSubmitEvent )
			{
				bFound = true;
				break;
			}
		}

		if ( !bFound )
		{
			var errormsg;
			if ( ( ekSubmitEvent === 'IDC_ANTRIEBSAUSWAHL_DIREKT' ) || ( ekSubmitEvent === 'IDC_ANTRIEBSUEBERSICHT_DIREKT' ) || 
			     ( ekSubmitEvent === 'IDC_DATEN_MECHANIK' ) || ( ekSubmitEvent === 'IDC_ANTRIEBSAUSWAHL' ) || 
			     ( ekSubmitEvent === 'IDC_MECH_BEWEGUNG' ) || ( ekSubmitEvent === 'IDC_DATEN_BEWEGUNG' ) || 
			     ( ekSubmitEvent === 'IDC_ANTRIEBSUEBERSICHT' ) )
				errormsg = document.getElementById( 'ERRORMSG_NAVIGATION' ).value;
			else if ( ( ekSubmitEvent === 'IDC_SPRACHEN' ) || ( ekSubmitEvent === 'IDC_SPRACHE_BUTTON' ) )
				errormsg = document.getElementById( 'ERRORMSG_LANGUAGE' ).value;
			else errormsg = document.getElementById( 'ERRORMSG_STAGE' ).value;
			alert( errormsg );
			return;
		}
	}
	// else no checking possible -> submit anyway

	if ( ekSubmitEvent !== 'IDC_SPRACHE_BUTTON' )
	{
		// submit the event to the IFrame without further ado
		ekSubmit( ekSubmitEvent, 'RFrame' );
	}
	else ekSubmit( ekSubmitEvent );
}


/**
 * mark the current selected item in the table of connection elements
 */
function InitElement()
{
	var disabled = document.getElementById( 'IDC_VORHER_BUTTON' ).disabled;
	if ( disabled )
		return;

	var name = document.getElementById( 'IDC_ELEMENT_POSITION' ).value;
	MarkElement( name );
}


/**
 * select connection element in the table of connection elements
 *
 * @param event: id of cell that received an onclick-event
 */
function SelectElement( event )
{
	var disabled = document.getElementById( 'IDC_VORHER_BUTTON' ).disabled;
	if ( disabled )
		return;

	var element = document.getElementById( event );
	if ( element.nodeName != 'TD' ) 
		element = getElementFromElementByTagName( element, 'TD' );
		
	// set selected element
	var name = element.id;
	var name1;
	switch(name){	
		case "IDC_GEAR_IMAGE" 	: name1 = 0; break;
		case "IDC_BP_IMAGE"		: name1 = 1; break;
		case "IDC_C_IMAGE"		: name1 = 2; break;
	}
	
	document.getElementById( 'IDC_ELEMENT_POSITION' ).value = name1;
	MarkElement( name );
}


/**
 * mark connection element as selected and all others as unselected
 *
 * @param name: id of connection element that is to be marked
 */
function MarkElement( name )
{
	// mark element as selected and deselect all prior selections
	var element_table = document.getElementById( 'IDC_ELEMENT_TAB_TABLE' );
	for ( var i = 0; i < element_table.rows[0].cells.length; i++ )	// we have only one row in the table
	{
		if ( element_table.rows[0].cells[i].id == name )
			element_table.rows[0].cells[i].style.backgroundColor = 'green';
		else element_table.rows[0].cells[i].style.backgroundColor = 'white';
	}		
}


/**
 * shows a .pdf-document for a tree node
 *
 * @param docId: id of document that should be shown
 */
function ShowDocument( docId )
{
	//var language = document.getElementById( 'EKCURRENTLANGUAGE' ).value;	
	docId = docId.replace( /\s/, "" );
	var nHeight	= 600;
	var nWidth  = 800;
    if ( window.screen ) 
    { 
        nWidth = window.screen.availWidth - 5; 
        nHeight = window.screen.availHeight - 5; 
    }
	var newWindowToolbar 	= "yes";
	var newWindowMenuBar 	= "yes";
    var newWindowAttributes = "menubar="+newWindowMenuBar+" toolbar="+newWindowToolbar+",width="+nWidth+",height="+nHeight+",top=0,left=0";
	if ( docId == "RELEASE_NOTES" )
	{
		var docpath = document.getElementById( 'DOCPATH_RELEASENOTES' ).value;
		//if ( language == "DE" )
		window.open( docpath + 'ReleaseNotes_IndraSize.pdf', 'NewWin', newWindowAttributes );
	}
	
	else if ( docId == "QUICKSTART" )
	{
		var docpath = 'Quickstart/';
		var element = document.getElementById( 'DOCPATH_QUICKSTART' );
		if ( element )
		    docpath = element.value;
	    window.open( docpath + 'Quickstart_IndraSize.pdf', 'NewWin', newWindowAttributes );
	}		
}


/**
 * signal that some working point value has been changed
 *
 * @param strTab: tab id of changed working point
 */
setWorkingPointsChanged = function( strTab )
{
	var element = document.getElementById( 'WORKING_POINTS_CHANGED_' + strTab );
	if ( !element )
		return;

	element.value = 'true';
}


/**
 * set the background of the edit field to yellow if it contains a security factor < 1
 *
 * @param strElementID: id of edit field for security factor
 */
setSecurityFactorColor = function( strElementID )
{
	var element = document.getElementById( strElementID );
	if ( !element )
		return;
	
	if ( (element.value-0) < 1 )
		element.style.backgroundColor = 'yellow';
	else element.style.backgroundColor = null;
}

