// ==============================================================================
// 												
// Author:		if this code doesn't work, it was written by Alan Smithee
//
// Copyright:	Plan Software GmbH, Saarbrcken
//  
// ==============================================================================

addEvent( window , 'load', initMaps, false );

function createMap( id, coords, titles ) 
{
	var mapImg = document.getElementById( id );
	var map = document.createElement( 'DIV' );
	
	map.style.position	= 'absolute';
	map.style.left 		= mapImg.style.left;
	map.style.top  		= mapImg.style.top;
	map.style.width 	= mapImg.style.width;
	map.style.height 	= mapImg.style.height;
	
	mapImg.parentNode.appendChild( map );
	img = mapImg.parentNode.removeChild( mapImg );
	
	img.style.top = '0px';
	img.style.left = '0px';
	
	map.appendChild( img );
	
	for ( var i=0; i < coords.length; i++ ) 
	{
		var coord = coords[i].split( ',' );
		var rect = document.createElement( 'DIV' );
		
		rect.title = titles[i];
		
		map.appendChild( rect );
		
		rect.id = id + '_' + i;
		rect.idx = i;
		rect.srcimg = id;
		rect.className = img.overstyle;
		rect.style.position = 'absolute';
		rect.style.top 		= coord[0] + 'px';
		rect.style.left 	= coord[1] + 'px';
		rect.style.width 	= coord[2] + 'px';
		rect.style.height 	= coord[3] + 'px';
		rect.style.backgroundImage = 'url( gfx/blank.gif )'; 
		rect.style.zIndex 	= 1000;
		
		addEvent( rect, 'click', toggleBorder, true );
		addEvent( rect, 'mouseover', setOver, true );
		addEvent( rect, 'mouseout', setOut, true );

		if ( parseInt( img.selected ) == i ) 
		{
			setSelected( rect );
			setBorder( rect );
		}
	}

	addEvent( map , 'click', dispose, false );
}


function setOver( evt ) 
{
	var originalTarget = evt.originalTarget;	
	var el = document.getElementById(originalTarget.id);	
	el.className = "MechImage_OVER"; 
}

function setOut( evt ) 
{
	var originalTarget = evt.originalTarget;	
	var el = document.getElementById(originalTarget.id);
	removeBorder( el );
	
	if ( parseInt ( document.isycat[el.srcimg + '_SELECTED'].value ) == parseInt( el.idx ) )
		setBorder( el );
}


function toggleBorder( evt ) 
{
	var originalTarget = evt.originalTarget;	
	var el = document.getElementById(originalTarget.id);
	var currSel = document.getElementById( el.srcimg + '_' + document.isycat[el.srcimg + '_SELECTED'].value );
	
	//if ( currSel )
	//	removeBorder( currSel );
	
	setSelected (el );
	setBorder( el );
	
	//window.event.cancelBubble = true;
	if (window.event)
	  	el = window.event.cancelBubble = true;
		
	ekSubmit( 'IDC_MECHANICS_IMAGE','RFrame' );
}


function setBorder( el ) 
{
	el.className = 'MechImage_SELECTED';
}


function removeBorder ( el ) 
{
	el.className = 'MechImage';
}


function setSelected ( el ) 
{
	document.isycat[el.srcimg + '_SELECTED'].value = el.idx;
}


function initMaps() 
{
	var imgs = document.getElementsByTagName( 'IMG' );
	
	for ( var i=0; i < imgs.length; i++ ) 
	{
		if ( imgs[i].getAttribute( 'type' ) == 'easygui-map' ) 
		{
			var coords = eval( imgs[i].id + '_COORDS' );
			var titles = eval( imgs[i].id + '_TITLES' );
			
			if ( ( coords != null ) && ( coords.length > 0 ) && ( titles != null ) && ( titles.length == coords.length ) )
				createMap( imgs[i].id, coords, titles );
		}
	}
	
	var currSel = document.getElementById( 'IDC_MECHANICS_IMAGE_' + document.isycat['IDC_MECHANICS_IMAGE_SELECTED'].value );
	if ( currSel )
		setBorder( currSel );
}


function dispose( evt ) 
{
	var originalTarget = evt.originalTarget;	
	var el = document.getElementById(originalTarget.id);
	var strVal = document.isycat[el.srcimg+ '_SELECTED'].value;
	currSel = document.getElementById( el.srcimg + '_' +strVal);// document.isycat[el.id + '_SELECTED'].value );
	
	if ( currSel )
		removeBorder( currSel );
}
